
QGIS Application - Bug report #16239

master: (much) slower rendering (and attribute table opening) time compared to 2.18.4

2017-02-27 05:10 AM - Giovanni Manghi

Status: Closed

Priority: High

Assignee:

Category: Map Canvas

Affected QGIS version:master Regression?: Yes

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 24149

Description

On the same machine, with the same settings, the rendering time of QGIS master seems much slower if compared to (for example) 2.18.4

For a 160k polygon features shapefile (which I can provide privately to a dev if necessary) the time to render the layer on master is around

30 seconds, while is around 7/8 on 2.18.4

For what is worth also the time to open the attribute table for the same vector is much slower on master, around 15 seconds compared to

around 5.

Related issues:

Related to QGIS Application - Bug report # 15752: Degradation of rendering pe... Closed 2016-10-25

Related to QGIS Application - Bug report # 16577: Extremely slower time to op... Closed 2017-05-18

Related to QGIS Application - Bug report # 16508: Opening Large Shape or orac... Closed 2017-05-03

Associated revisions

Revision b97a980b - 2017-05-22 11:07 AM - Nyall Dawson

Greatly speed up attribute table loading

Don't advise for rows added when a model reset is in progress.

Otherwise the rows are tested for sort order, etc triggering

a bunch of useless calculations, given that the model is in

the process of being reset anyway.

Tested using a 150k point shapefile, decreased attribute table

load times from 50+ seconds to 4 seconds.

Refs #16577, #16239

Revision ebd3e0d7 - 2017-05-23 01:35 AM - Nyall Dawson

Greatly speed up attribute table loading

Don't advise for rows added when a model reset is in progress.

Otherwise the rows are tested for sort order, etc triggering

a bunch of useless calculations, given that the model is in

the process of being reset anyway.

Tested using a 150k point shapefile, decreased attribute table
load times from 50+ seconds to 4 seconds.

Refs #16577, #16239

(forward port from b97a980b99a32f7cbbb8cc32ac6a781246df1171)

Revision 0b95c776 - 2017-05-23 01:59 AM - Nyall Dawson

Don't prefetch attribute table sort values when no sorting set

Shaves some seconds off opening the attribute table in certain

circumstances (no sorting applied)

Refs #16577, #16239

Revision 4acc4805 - 2017-05-23 08:05 AM - Nyall Dawson

Don't prefetch attribute table sort values when no sorting set

Shaves some seconds off opening the attribute table in certain

circumstances (no sorting applied)

Drops load time for table from 100 seconds to 50 seconds for a

2.6 million feature shapefile, and from 6.5 seconds to 3.5 seconds

for a 160k feature shapefile.

Refs #16577, #16239

(cherry-picked from 0b95c77)

Revision ce74d57b - 2018-06-16 07:36 AM - Nyall Dawson

[postgres] Really disable dynamic queue size

The original commit speed up some layers, but regressed

performance for others. It was decided to revert the

dynamic queue feature, but it seems this was never actually

done.

Fixes #16239, #19203

History

#1 - 2017-02-27 10:37 AM - Nyall Dawson

Can you shoot me a link to the data/project? Nyall.dawson@gmail.com

#2 - 2017-02-27 11:37 AM - Giovanni Manghi

Nyall Dawson wrote:
Can you shoot me a link to the data/project? Nyall.dawson@gmail.com

sent using DropBox. Cheers!

#3 - 2017-03-03 02:28 AM - Giovanni Manghi

see also #15752

#4 - 2017-04-01 07:16 PM - Nyall Dawson

- Status changed from Open to Feedback

Giovanni,

Are both builds you are using for comparison debug builds? Or are you comparing a release build vs debug build?

#5 - 2017-04-03 06:34 AM - Giovanni Manghi

- Status changed from Feedback to Open

Nyall Dawson wrote:

Giovanni,

Are both builds you are using for comparison debug builds? Or are you comparing a release build vs debug build?

I used qgis-master from osgeo4w and 2.14/2.18 from the very same osgeo4w install within the same machine.

#6 - 2017-04-04 05:56 AM - Andre Jesus

I guess the issue in #15752 can be merged into this one, as the render time is rising in all data sources.

Using Windows 10 64 Bits, OSGeo4W installer 64 Bits:

3x avg render time, MSSQL

2.14.13

    3100 ms

2.99.0

    8800 ms  +64.7%

3x avg render time, Postgres

2.14.13

    1300 ms

2.99.0

    3600 ms  +63.8%

Project info:
http://i.imgur.com/hY79Ngd.png

As said in #15752, if we compare It to 2.8.9 version the time difference is absurd

#7 - 2017-04-04 07:01 AM - Jürgen Fischer

Are you comparing builds writing debugging output (qgis-ltr-dev/qgis-rel-dev/qgis-dev; see corresponding note in the about box) and builds not writing

debugging output (qgis/qgis-ltr)?   Writing debugging output has a performance impact.

#8 - 2017-04-04 07:46 AM - Andre Jesus

Jürgen Fischer wrote:

Are you comparing builds writing debugging output (qgis-ltr-dev/qgis-rel-dev/qgis-dev; see corresponding note in the about box) and builds not

writing debugging output (qgis/qgis-ltr)?   Writing debugging output has a performance impact.

Yes, I was: qgis-ltr (2.14.13) vs qgis-dev (2.99.0). And you are right, the render time using qgis-ltr-dev is bigger:

2.14.13-2 (qgis-ltr-dev)

MSSQL: 5100 ms

Postgres: 3000 ms

But again, please check #15752. 

Every version since 2.10.x has constantly rising the render time by a high percentage.

#9 - 2017-04-12 04:52 PM - Nyall Dawson

- Status changed from Open to Feedback

I believe this report can be closed - it seems the issue was stemming from comparing the debug vs release builds.

#15752 describes a regression in the speed of the mssql provider. I think this is a separate issue which should be left open.

#10 - 2017-04-13 03:14 AM - Giovanni Manghi

Nyall Dawson wrote:

I believe this report can be closed - it seems the issue was stemming from comparing the debug vs release builds.

#15752 describes a regression in the speed of the mssql provider. I think this is a separate issue which should be left open.

before closing I can compile master with no debug output and try again. Thanks.

#11 - 2017-04-30 05:08 PM - Giovanni Manghi

- Regression? set to Yes
#12 - 2017-04-30 05:08 PM - Giovanni Manghi

- Priority changed from Severe/Regression to High

#13 - 2017-05-01 01:10 AM - Giovanni Manghi

- Easy fix? set to No

#14 - 2017-05-01 02:52 PM - Alexander Bruy

- Description updated

Probably related to #15752

#15 - 2017-05-18 11:24 PM - Giovanni Manghi

Nyall Dawson wrote:

I believe this report can be closed - it seems the issue was stemming from comparing the debug vs release builds.

#15752 describes a regression in the speed of the mssql provider. I think this is a separate issue which should be left open.

see #16577 (datasouces shapefiles)

#16 - 2017-05-19 08:56 AM - Jürgen Fischer

- Related to Bug report #16577: Extremely slower time to open attribute table in 2.18.7 compared to 2.14.14 added

#17 - 2017-05-19 09:02 AM - Jürgen Fischer

- Related to Bug report #16508: Opening Large Shape or oracle table (table) takes more time then before added

#18 - 2017-05-20 09:32 PM - Giovanni Manghi

- Affected QGIS version changed from master to 2.18.7

- Status changed from Feedback to Open

Nyall Dawson wrote:

I believe this report can be closed - it seems the issue was stemming from comparing the debug vs release builds.

#15752 describes a regression in the speed of the mssql provider. I think this is a separate issue which should be left open.

Hi Nyall,

I think that this new (among the many others) report speaks volumes:

https://lists.osgeo.org/pipermail/qgis-psc/2017-May/005258.html

#19 - 2017-07-25 10:58 PM - Giovanni Manghi

- Affected QGIS version changed from 2.18.7 to master
#20 - 2018-06-16 07:35 AM - Nyall Dawson

- Status changed from Open to Closed

- % Done changed from 0 to 100

Applied in changeset commit:qgis|ce74d57b2e41b59d5a2773b8539dc089a802d786.
